/* ==========================================================================*/
/* - - - - - - - - - - - -  A t o D , C  - - - - - - - - - - - - - - - - - - */
/* ==========================================================================*/
/*	Created   07-06-2004   M. Wheatley                                       */
/*	Modified  07-10-2004   MW                                                */
/*.........................................................................  */
/* Module to intiialize and use 12 Bit A/D Module                            */
/*.........................................................................  */

/*---------------------------------------------------------------------------*/
/*------------------------> I N C L U D E S <--------------------------------*/
/*---------------------------------------------------------------------------*/
#include <p30f6014.h>
#include <adc12.h>
#include "common.h"
#include "timers.h"
#include "atod.h"

/*---------------------------------------------------------------------------*/
/*----------------> P R O C E S S O R    S P E C I F I C <-------------------*/
/*---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------*/
/*--------> T Y P E D E F S   U N I O N S    S T R U C T U R E S <-----------*/
/*---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------*/
/*--------------------> L O C A L   D E F I N E S <--------------------------*/
/*---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------*/
/*----------------> E X T E R N A L  R E F E R E N C E S <-------------------*/
/*---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------*/
/*--------------> G L O B A L  M E M O R Y  A L L O C A T I O N <------------*/
/*---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------*/
/*--------------> L O C A L  M E M O R Y  A L L O C A T I O N <--------------*/
/*---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------*/
/*--------------------------> P R O T O T Y P E S <--------------------------*/
/*---------------------------------------------------------------------------*/
void InitAD(void);
unsigned int GetADValue(char pot);

/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/
/*                             -------------                                 */
/*                            | I n i t A D |                                */
/*                             -------------                                 */
/*    This initializes the 12 bit A/D.                                       */
/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/
void InitAD(void)
{
	TRISBbits.TRISB4 = 1;	//make sure A/D port pins are inputs
	TRISBbits.TRISB5 = 1;
	TRISBbits.TRISB7 = 1;
	TRISBbits.TRISB8 = 1;
	ADCON1bits.ADON = 0; /* turn off ADC */
	SetChanADC12( ADC_CH0_POS_SAMPLEA_AN4 &
					ADC_CH0_POS_SAMPLEA_AN5 &
					ADC_CH0_POS_SAMPLEA_AN7 &
					ADC_CH0_POS_SAMPLEA_AN8 &
					ADC_CH0_POS_SAMPLEA_AN15 &
					ADC_CH0_NEG_SAMPLEA_NVREF &
					ADC_CH0_POS_SAMPLEB_AN0 &
					ADC_CH0_NEG_SAMPLEB_NVREF);
	ConfigIntADC12(ADC_INT_DISABLE);
	OpenADC12(	ADC_MODULE_ON &
					ADC_IDLE_CONTINUE &
					ADC_FORMAT_INTG &
					ADC_CLK_AUTO &
					ADC_AUTO_SAMPLING_ON,
				ADC_VREF_AVDD_AVSS &
					ADC_SCAN_ON &
					ADC_ALT_BUF_OFF &
					ADC_ALT_INPUT_OFF &
					ADC_SAMPLES_PER_INT_4,
				ADC_SAMPLE_TIME_31 &
					ADC_CONV_CLK_SYSTEM &
					ADC_CONV_CLK_32Tcy,
				ENABLE_AN4_ANA &
					ENABLE_AN5_ANA &
					ENABLE_AN6_ANA &
					ENABLE_AN8_ANA &
					ENABLE_AN15_ANA,
				(BIT4|BIT5|BIT6|BIT8|BIT15)	//errata requires ch15 ???
			);
}

/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/
/*                        ---------------------                              */
/*                       | G e t A D V a l u e |                             */
/*                        ---------------------                              */
/*    Called to Read the latest A/D value.                                   */
/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/
unsigned int GetADValue(char pot)
{
	return ReadADC12(pot);
}
