/* ==========================================================================*/
/* - - - - - - - - - - - - -  C O D E C , H  - - - - - - - - - - - - - - - - */
/* ==========================================================================*/
/*	Created   06-14-2004   M. Wheatley                                       */
/*	Modified  06-14-2004   MW                                                */
/*.........................................................................  */
/* Si3000 Codec Module Include File                                          */
/*.........................................................................  */
#ifndef CODEC_MODULE
#define CODEC_MODULE
/*>>>>>>>>>>>>>>>>>>>>>> Global Defines <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<*/
#define CODEC_CTRL_1 1
 #define CODEC_PARM_CPD (1<<0)
 #define CODEC_PARM_MPD (1<<1)
 #define CODEC_PARM_HPD (1<<2)
 #define CODEC_PARM_LPD (1<<3)
 #define CODEC_PARM_SPD (1<<4)
 #define CODEC_PARM_SR (1<<7)
#define CODEC_CTRL_2 2
 #define CODEC_PARM_DL2 (1<<1)
 #define CODEC_PARM_DL1 (1<<2)
 #define CODEC_PARM_PLL (1<<3)
 #define CODEC_PARM_HPFD (1<<4)
#define CODEC_N1 3
#define CODEC_M1 4
#define CODEC_RXGAIN 5
 #define CODEC_PARM_IIR (1<<0)
 #define CODEC_PARM_HIM (1<<1)
 #define CODEC_PARM_MCM (1<<2)
 #define CODEC_PARM_MCG0 (0<<3)
 #define CODEC_PARM_MCG1 (1<<3)
 #define CODEC_PARM_MCG2 (2<<3)
 #define CODEC_PARM_MCG3 (3<<3)
 #define CODEC_PARM_LIM (1<<5)
 #define CODEC_PARM_LIG0 (0<<6)
 #define CODEC_PARM_LIG1 (1<<6)
 #define CODEC_PARM_LIG2 (2<<6)
 #define CODEC_PARM_LIG3 (3<<6)
#define CODEC_ADCVOL 6		//5 bit value in bits 2 thru 6
 #define CODEC_PARM_HOM (1<<0)
 #define CODEC_PARM_LOM (1<<1)
#define CODEC_DACVOL 7		//5 bit value in bits 2 thru 6
 #define CODEC_PARM_SRM (1<<0)
 #define CODEC_PARM_SLM (1<<1)
#define CODEC_STATUS 8
 #define CODEC_PARM_LOSC (1<<5)
 #define CODEC_PARM_SRSC (1<<6)
 #define CODEC_PARM_SLSC (1<<7)
#define CODEC_ATTN 9
 #define CODEC_PARM_SOT0 (0<<0)
 #define CODEC_PARM_SOT1 (1<<0)
 #define CODEC_PARM_SOT2 (2<<0)
 #define CODEC_PARM_SOT3 (3<<0)
 #define CODEC_PARM_LOT0 (0<<2)
 #define CODEC_PARM_LOT1 (1<<2)
 #define CODEC_PARM_LOT2 (2<<2)
 #define CODEC_PARM_LOT3 (3<<2)

/*>>>>>>>>>>>>>>>>>>>>>>> External memory <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<*/
extern unsigned int* pActiveRxBuf;
extern unsigned int* pActiveTxBuf;

/*>>>>>>>>>>>>>>>>>>>>>> External functions <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<*/
extern void InitCodecLcd( void );
extern void WriteCodecCtrl( unsigned char adr, unsigned char parm );
extern unsigned char ReadCodecCtrl( unsigned char adr );

#endif

